// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 Lab Assessment.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2020T3, Lab Assessment 3
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;

import java.awt.Color;
import java.util.ArrayList;

/**
 * Question 1. Basic Java                               [27 marks]
 * 
 * (a) [4 marks] Writing methods.
 * 
 * Define a method called myMethod in this class. The method must:
 *   - have two parameters:
 *      1. n, an integer
 *      2. text, a String
 *   - Print the string stored in text n times to the UI.
 *
 *   For example, the following code would print 
 *   "I must not play games in class." 10 times.
 *   
 *      myMethod(10, "I must not play games in class.");
 * 
 * (b) [6 marks] Calling methods on objects.
 * 
 * Given the Circle class, complete the useCircle() method below
 * so that it:
 *  - makes a blue circle at (250,100) with a size of 35
 *  - makes a green circle at (75, 300) with a size of 20
 *  - draws both circles on the screen
 *  - makes the first circle grow 2 times
 *  - makes the second circle grow 3 times
 *  - shrinks the first circle 20 pixels
 *  - shrinks the second circle 12 pixels
 * 
 * (c) [8 marks] Arrays
 * 
 * Complete the averageArray() method below so that it computes the average of the
 * numbers in the nums array.
 *   - When testing your code, check that the answer is 3.375.
 * 
 * 
 * (d) [9 marks] ArrayLists
 * 
 * Complete the countPositives() method below so that it counts and prints the number
 * of positive values that appear in the ArrayList of Doubles stored in nums.
 * 
 * For example, if the user enters ”-1 8.8 -2.1 0 9 2 5”, it should print 
 * ”There were 4 positive numbers.”
 * 
 *  NB. Zero is not positive or negative.
 */
public class Program1 {


    /**
     * Calls myMethod(...) and prints things out.
     * 
     * DO NOT CHANGE THIS METHOD.
     * 
     * Use this to test that your answer to 1 (a) works correctly.
     */
    public void printStuff() {
        UI.clearText();
        String text = "All Work And No Play Makes Jack A Dull Boy";
        int n = 10;
        this.myMethod(n, text);
        UI.println();
        // If myMethod works correctly, this should look a bit like the Eiffel Tower
        this.myMethod(4,"       #");
        this.myMethod(4,"      ###");
        this.myMethod(3,"     #####");
        this.myMethod(2,"    #######");
        this.myMethod(2,"   ## ### ##");
        this.myMethod(1,"  ###########");
        this.myMethod(2,"  ##  # #  ##");
        this.myMethod(1," ##  #   #  ##");
        this.myMethod(1,"##  #     #  ##");
    }

    /**
     * (a) Define a method called myMethod that does not return a value.
     *     It must have two parameters: an integer and a String.
     *     
     *     The method must print out the String parameter a number of times
     *     equal to the value of the integer parameter.
     */
    /*# YOUR CODE HERE*/

    /**
     * (b) Complete this method so that it uses the Circle class and:
     * - makes a blue circle at (250,100) with a size of 35
     * - makes a green circle at (75, 300) with a size of 20
     * - draws both circles on the screen
     * - makes the first circle grow 2 times
     * - makes the second circle grow 3 times
     * - shrinks the first circle 20 pixels
     * - shrinks the second circle 12 pixels
     */
    public void useCircle() {
        /*# YOUR CODE HERE */

    }

    /**
     * (c) Complete this method so that it calculates the average of all the
     *     numbers in the nums parameter.
     * ( when testing your code using the button, check that the answer is 3.375 ).
     */
    public void averageArray(int[] nums) {
        /*# YOUR CODE HERE */

    }

    /**
     * (d) Complete this method so that it counts and prints the number of positive values
     * that appear in the ArrayList of Doubles stored in nums.
     * <p>
     * For example, if the user enters "-1 8.8 -2.1 0 9 2 5", it should print
     * "There were 4 positive numbers."
     *
     * ( Zero is not positive or negative )
     */
    public void countPositives() {
        ArrayList<Double> nums = UI.askNumbers("Enter numbers here: ");
        /*# YOUR CODE HERE */

    }

    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("(a) myMethod(...)", this::printStuff);
        UI.addButton("(b) useCircle()", this::useCircle);
        UI.addButton("(c) averageArray(...)", () -> {this.averageArray(new int[]{2,6,3,4,1,2,9,0});});
        UI.addButton("(d) countPositives()", this::countPositives);
        UI.addButton("Quit", UI::quit);
        UI.setWindowSize(800, 500);
        UI.setDivider(0.5);
    }

    public static void main(String[] args) {
        new Program1().setupGUI();
    }
}
